import { jsx as _jsx } from "react/jsx-runtime";
import { isFunction, pick, getControl, } from 'handie-react';
import { DateFilterStructuralWidget } from 'handie-react/dist/widgets/class';
export default class DateRangeDateFilterWidget extends DateFilterStructuralWidget {
    handleRangeChange(_, dates) {
        this.onRangeChange(dates);
        if (this.searchImmediately) {
            this.$$view.reload();
        }
    }
    render() {
        const DateRangePicker = getControl('DateRangePicker');
        const { disableDate, showNow } = pick(this.config, [
            'disableDate',
            'showNow',
        ]);
        const options = { showNow };
        if (isFunction(disableDate)) {
            options.disableDate = (date) => disableDate(this.getRangeValue(), date, this.$$search.getValue());
        }
        return DateRangePicker ? (_jsx(DateRangePicker, { value: this.getRangeValue(), placeholder: this.getRangePlaceholders(), format: this.config.format, separator: this.getSeparator(), pickerOption: options, onChange: this.handleRangeChange.bind(this) }, void 0)) : null;
    }
}
