import { jsx as _jsx } from "react/jsx-runtime";
import { isNumber, getControl } from 'handie-react';
import { EnumFilterStructuralWidget } from 'handie-react/dist/widgets/class';
export default class SelectEditEnumFilterWidget extends EnumFilterStructuralWidget {
    handleOptionChange(value) {
        this.onChange(value == null ? '' : value);
        if (this.searchImmediately) {
            this.$$view.reload();
        }
    }
    render() {
        const Select = getControl('Select');
        const Option = getControl('Option');
        const children = this.state.options.map((opt) => Option ? (_jsx(Option, { label: opt.label, value: opt.value }, `Option${opt.value}OfSelectEditEnumFilterWidget`)) : null);
        const showEmptyValueOption = this.getCommonBehavior('filter.showEmptyValueOption', false);
        if (showEmptyValueOption && Option) {
            children.unshift(_jsx(Option, { label: this.getCommonBehavior('filter.emptyValueOptionLabel'), value: "" }, "OptionAllOfSelectEditEnumFilterWidget"));
        }
        const props = {
            value: this.props.value,
            placeholder: this.getPlaceholder(),
            clearable: !showEmptyValueOption,
        };
        const { className, width } = this.config;
        if (className) {
            props.className = className;
        }
        if (width) {
            props.style = { width: isNumber(width) ? `${width}px` : width };
        }
        return Select ? (_jsx(Select, Object.assign({}, props, { onChange: this.handleOptionChange.bind(this) }, { children: children }), void 0)) : null;
    }
}
